
#ifdef __cplusplus
extern "C"
{
#endif

	
#include "UWater_power_app.h"
#include "UWater_adc_driver.h"
#include "UWater_rtcc_driver.h"
#include "soe.h"
/*------------------------------ Variable Define -------------------------------------*/

static u8 s_g_voltage_stat = NORMAL_POWER; // ʼԴѹ
static u8 s_g_power_machine_state_num = POWER_SYS_S0; // Դѹ⴦״̬
static u8 s_power_adc_done = 0; // ADװɱ־
static u32 s_power_adc_result = 0; // ADת
static u8 s_power_reset=0;
	

u8 s_power_sleep_sum = 0;
u8 s_power_sleep_flag = FALSE; // Դ֮
u32 temp_value;

/*------------------------------ Function Define -------------------------------------*/


/***********************صѹʹ***************************
Function:    void PowerADCEnable(void)  void PowerADCDisable(void)
Description:
Input:
Return:
Others:
 ****************************************************************/
 void PowerADCEnable(void)
 {
		stc_gpio_cfg_t stcGpioCfg;
		DDL_ZERO_STRUCT(stcGpioCfg);
		stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ
		stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->
		stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
		stcGpioCfg.enPd = GpioPdDisable;
		stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©:رտ©,ʹ
		stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
		Gpio_Init(BAT_CHECK_ENPORT, BAT_CHECK_ENPIN, &stcGpioCfg);
		Gpio_WriteOutputIO(BAT_CHECK_ENPORT, BAT_CHECK_ENPIN, TRUE);
 }
 
void PowerADCDisable(void)
{	
		stc_gpio_cfg_t stcGpioCfg;
		DDL_ZERO_STRUCT(stcGpioCfg);
		stcGpioCfg.enDir = GpioDirOut;    ///< ˿ڷ
		stcGpioCfg.enDrv = GpioDrvL;      ///< ˿->
		stcGpioCfg.enPu = GpioPuDisable;  ///< ˿->
		stcGpioCfg.enPd = GpioPdDisable;
		stcGpioCfg.enOD = GpioOdDisable;  ///< ˿ڿ©:رտ©,ʹ
		stcGpioCfg.enCtrlMode = GpioAHB;  ///< ˿/ֵĴ߿ģʽ->AHB
		Gpio_Init(BAT_CHECK_ENPORT, BAT_CHECK_ENPIN, &stcGpioCfg);
		Gpio_WriteOutputIO(BAT_CHECK_ENPORT, BAT_CHECK_ENPIN, FALSE);
}

/***********************ϵʼ***************************
Function:    void PowerManageInitSys(void)
Description:
Input:
Return:
Others:
 ****************************************************************/
void PowerManageInitSys(void)
{
    s_g_voltage_stat = NORMAL_POWER; // ʼԴѹ
    s_g_power_machine_state_num = POWER_SYS_S0; // Դѹ⴦״̬
    RtccSetTimer(RTCC_TIMER_BAT_NUM, 30);        //ϵ30sصѹ
    PowerADCDisable();
}

/***********************ѯǷѹϢ***************************
Function:    u8 PowerCheckStatusSys(void)
Description:  ѯǰǷǷѹ
Input:
Return:     LOW_POWER صѹ   NORMAL_POWERѹ
Others:
 ****************************************************************/
u8 PowerCheckStatusSys (void)
{
    return (s_g_voltage_stat);
}
/***********************ѯѹֵϢ***************************
Function:    u16 PowerCheckValueSys(void)
Description:  ѯǰֵ,ֵ
Input:
Return:    Ŵ100 u16,16
Others:
 ****************************************************************/
u16 PowerCheckValueSys(void)
{
	return ((u16)temp_value);
}
/***********************ӿ***************************
Function:    void PowerMachineSys (void)
Description:  Ӧò㽨ӿ
Input:
Return:
Others:
 *****************************************************************/
void PowerMachineSys(void)
{
	static u8 low_power_sum = 0;
		
    switch (s_g_power_machine_state_num)
    {
    case POWER_SYS_S0:
		if (0 == RtccCheckTimer(RTCC_TIMER_BAT_NUM))
		{
			if(TASK_IDLE == AdcIfIdle())
			{
				PowerADCEnable();
				AdcStartConvert(POWER_CHECK_CHANNEL, POWER_CHECK_NUM, POWER_CHECK_INTERVAL, &s_power_adc_result, &s_power_adc_done);
				s_g_power_machine_state_num = POWER_SYS_S1;
			}
		}
        break;
    case POWER_SYS_S1:
        if (TRUE == s_power_adc_done)
        {
            PowerADCDisable();	
            if (ADC_OK == AdcGetStatus())
            {
                if(s_power_adc_result <= LOW_POWER_ADC_VALUE)    //Ƿѹ
                {
                    low_power_sum ++;
					RtccSetTimer(RTCC_TIMER_BAT_NUM, VOLTAGE_TEST_INTERVAL);
                    if(low_power_sum >=6)
                    {
						SaveNewSoe(SOE_BAT_LOW_LEVEL,SOE_REMARK_NOR);	//SOE
                        s_g_voltage_stat = LOW_POWER;
                        low_power_sum = 0;
                        RtccSetTimer(RTCC_TIMER_BAT_NUM, VOLTAGE_TEST_INTERVAL); //ʱ12h
                    }
                }
                else
                {
                    s_g_voltage_stat = NORMAL_POWER;
                    low_power_sum = 0;
                    RtccSetTimer(RTCC_TIMER_BAT_NUM, VOLTAGE_TEST_INTERVAL); //ʱ12h
                }
                temp_value = s_power_adc_result * 500;  //((v/2)/2.5)*4096 = s_power_adc_result
                temp_value = temp_value/4096;
				if(s_power_reset==0)//ݳ
				{
					s_power_reset =1;
					if(temp_value<360)
					{
						RtccSetTimer(RTCC_TIMER_BAT_NUM, 10);//10²
					}
				}
				s_g_power_machine_state_num = POWER_SYS_S0;
           }
       }
        break;
    default:
        break;
    }
}

/***********************ߴ***************************
Function:    u8 PowerIfSleepSys(void)
Description:
Input:
Return:
Others:
 *****************************************************************/
u8 PowerIfSleepSys(void)
{
	if (s_g_power_machine_state_num == POWER_SYS_S0)
	{
		return TRUE;
	}
	return FALSE;
}

void PowerPreSleepSys(void)
{
//    PowerADCDisable(); //ܽſ
}




//ʱ䲻ߴ2017-7-21/////////////////////////////////////

/**************************************************
Function:    void PowerUnSleepClearSumSys (void)
Description:
Input:
Return:
Others:
 *****************************************************************/
void PowerUnSleepClearSumSys(void)
{
    s_power_sleep_sum = 0;
}


/**************************************************
Function:    u8 PowerUnSleepSaveDataMsgSys (void)
Description:
Input:
Return:
Others:
 *****************************************************************/
u8 PowerUnSleepSaveDataMsgSys(void)
{
    return s_power_sleep_flag;
}

/**************************************************
Function:    void PowerUnSleepSaveDataClearMsgSys (void)
Description:  
Input:
Return:
Others:
 *****************************************************************/
void PowerUnSleepSaveDataClearMsgSys(void)
{
    s_power_sleep_flag = FALSE;
}


void PowerUnSleepSumAddSys(void)
{
	s_power_sleep_sum++;
	if (s_power_sleep_sum >= 10)//10min
	{
		s_power_sleep_sum = 0;
		s_power_sleep_flag = TRUE;
	}
}




#ifdef	__cplusplus
}
#endif


