/**
  ******************************************************************************
  * @file    lvd.h
  * @author  (C)2015, Qindao ieslab Co., Ltd
  * @version V1.0
  * @date    2015-12-25
  * @brief   the function of the entity of system processor
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __UWater_CLKTRIM_DRIVER_H
#define __UWater_CLKTRIM_DRIVER_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "ddl.h"
#include "type.h"

#define TRIM_DONE               0xFF         //У׼ɹ
#define TRIM_OVERFLOW           0xEE         //У׼ʱӼ

#define REF_CON                 (32768u)        //οʱӼֵ32768hz3277ԼΪ100ms 
#define CAL_CON_TARGET          (4000000u)//3840u        //У׼ʱӼĿֵ38400hz3840Ϊ100ms 
#define ERROR_RANGE             19u          //У׼ʱΧֵ3840*0.005Լ0.5%

#define TRIM_MAX_NUM            60           //У׼ģУ׼
#define EVERYDAY_TRIM_MAX_NUM   50           //У׼ģÿУ׼
/*¶Ȳֵ λ϶*/
#define TEMPERTURE_DIFF 5.0f
enum clktrim_adjust_direction
{
	DIRECTIONLESS = 0,
	UPWARD,
	DOWNWARD	
};

typedef struct
{
	u8 adjust_direction_flg;   //ı־
	u32 diff_value;             //ֵ
}CLKTRIM_INFO;



enum clktrim_machine_state_num //ʱУ׼״̬״̬
{
	CLKTRIM_MACHINE_S0 = 0,
	CLKTRIM_MACHINE_S1,
	CLKTRIM_MACHINE_S2,
	CLKTRIM_MACHINE_S3
};

/* MACRO Define---------------------------------------------------------------*/
#define SYS_FREQ                4000000

#if(SYS_FREQ == 4000000)
#define SYSCTRL_FREQ            SysctrlRchFreq4MHz
#elif(SYS_FREQ == 8000000)
#define SYSCTRL_FREQ            SysctrlRchFreq8MHz
#elif(SYS_FREQ == 16000000)
#define SYSCTRL_FREQ            SysctrlRchFreq16MHz
#elif(SYS_FREQ == 24000000)
#define SYSCTRL_FREQ            SysctrlRchFreq24MHz
#endif


/* variables Define---------------------------------------------------------------*/


/* Function Declare------------------------------------------------------------*/
extern void ClkTrimInit(void);
u8 ClkTrimIfIdle(void);
void ClktrimMainMachine(void);
#ifdef __cplusplus
}
#endif

#endif /* __UWater_UART_DRIVER_H */
