/**
  ******************************************************************************
  * @file    hc32_key_driver.h
  * @author  (C)2020, Qindao ieslab Co., Ltd
  * @version V1.0
  * @date    2020-7-1
  * @brief   the function of the entity of system processor
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __UWater_KEY_DRIVER_H
#define __UWater_KEY_DRIVER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ddl.h"
#include "type.h"
#include "sys_config.h"

/* MACRO Define---------------------------------------------------------------*/


#if (HARDWARE_VERSION==0x14)//Ǳ
//IO
#define KEY_GPIO                GpioPortE   //HD
#define KEY_PIN                 GpioPin11	//HD

#define KEY_IRQ					PORTC_E_IRQn 
#define KEY_PRIORITY     		(IrqLevel3)
//IO
#define TCH_KEY_GPIO                GpioPortC    //HDж
#define TCH_KEY_PIN                 GpioPin10	//HD

#define TCH_KEY_POWER_GPIO                GpioPortF    //HDԴ
#define TCH_KEY_POWER_PIN                 GpioPin6	//HDԴ

#define TCH_KEY_IRQ					PORTC_E_IRQn 
#define TCH_KEY_PRIORITY     		(IrqLevel3)

#elif (HARDWARE_VERSION==0x18)//ԲǱ
//IO
#define KEY_GPIO                GpioPortE   //HD
#define KEY_PIN                 GpioPin11	//HD

#define KEY_IRQ					PORTC_E_IRQn 
#define KEY_PRIORITY     		(IrqLevel3)

//IO
#define TCH_KEY_GPIO                GpioPortC    //HDж
#define TCH_KEY_PIN                 GpioPin13	//HD

#define TCH_KEY_POWER_GPIO          GpioPortF    //HDԴ
#define TCH_KEY_POWER_PIN           GpioPin1	//HDԴ

#define TCH_KEY_IRQ					PORTC_E_IRQn 
#define TCH_KEY_PRIORITY     		(IrqLevel3)
#endif
// (ҪӲ޸ĵ͵ƽǰ»Ǹߵƽǰ)
#define  KEY_NO_PRESS           	(u32)1
#define  KEY_PRESS              	(u32)(!KEY_NO_PRESS)

//жϱ
#define  KEY_RISING_EDGE          0
#define  KEY_FALLING_EDGE         (!KEY_RISING_EDGE)

//
#define  NONE_KEY       0
#define  MEGNET_KEY     1
#define  TOUCH_KEY      2

//¼
#define NO_EVENT          0x00	 //޲
#define SHORT_PRESS       0x01	 //̰¼
#define LONG_PRESS        0x02	 //¼
#define ERR_PRESS         0x04	 //쳣¼
#define LONGLONG_PRESS    0x08   //¼

#define SHORT_START       1        //̰ʼʱ
#define SHORT_END         200      //ֹ̰ʱ
#define LONG_INTERVAL     100      //MSGʱ
#define LONG_END          60       //ֹʱ 60s޸Ϊ60s


//ü
#define KEY_CHECK_TIME    2   	   //10msһ
//ÿʹô
#define TCH_PRESS_LIMIT_CNT  30
//״̬״̬
#define KEY_M_S0 0              //״̬״̬
#define KEY_M_S1 1              //״̬״̬
#define KEY_M_S2 2              //״̬״̬
#define KEY_M_S3 3              //״̬״̬
#define KEY_M_S4 4              //״̬״̬
#define KEY_M_S5 5              //״̬״̬
#define KEY_M_S6 6              //״̬״̬
#define KEY_M_S7 7              //״̬״̬
#define KEY_M_S8 8              //״̬״̬
#define KEY_M_S9 9              //״̬״̬

//ⲿж
#define EXTI0_OPEN        0     //A
#define EXTI1_OPEN        0     //B
#define EXTI2_OPEN        1     //C
#define EXTI3_OPEN        0     //D
#define EXTI4_OPEN        1     //E
#define EXTI5_OPEN        0     //F


/* Function Declare------------------------------------------------------------*/
void KeyInit(void);						//ʼ
u8 KeyIfIdle(void);						//Ƿ
void KeyMachineDriver(void);		//״̬
u8 KeyCheckMsg(void);					//ⰴϢ
void KeyClearMsg(u8 msg);			//Ϣ
u8 KeyIfSleep(void);						//Ƿ
void KeyPreSleep(void);				//ǰӿ
void KeyWakeSleep(void);				//ѽӿ
u8 TchKey_GetPressLimitState(void);

#ifdef __cplusplus
}
#endif

#endif /* __UWater_KEY_DRIVER_H */
