/*******************************************************************************
* @Copyright (c)    :(C)2017, Qingdao ieslab Co., Ltd
* @FileName         :GP22Gas_valve_driver.h
* @Author           :Kv-L
* @Version          :V1.0
* @Date             :201759 13:30:23
* @Description      :the function of the entity of GP22Gas_valve_driver.h
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#include "sys_config.h"

#ifndef VALVE_DRIVER_H
#define	VALVE_DRIVER_H

#ifdef	__cplusplus
extern "C" {
#endif 
	
/* Includes ------------------------------------------------------------------*/
#include "sys_config.h"
#include "ddl.h"
#include "type.h"
//#include "UWater_frame_app.h"

/*EEPַӳ*/
//#define VALVE_ADDR_BASE     EEP_BASE_VALVE      /*ϵͳȷ*/
//#define VALVE_ERR_BASE    (VALVE_ADDR_BASE + 1) 

#define CHANNEL_VALVE_CHECK     13			/*ref ADC_channels   HD 2020-09-16*/

#define VALVE_PAUSE_TIME	200        	/*ͣʱ1sѡ5msʱTIMER_5MS_VALVE*/
#define VALVE_CHECK_TIME	100	 		/*ʱ0.5sѡ5msʱTIMER_5MS_VALVE*/
#define VALVE_ERROR_MAX		2	 		/*ת*/

//adcѹϢ
#define VALVE_HIGH_POWER          1         //ת
#define VALVE_NORMAL_POWER        0         //
//תADֵ
#define VALVE_HOGH_ADC_VALUE      (280/2) //(ʵתADC=310,0.5R->ת370mA;趨ת280mA-->0.5R--->ADC=230;150mA--->0.5R--->adc=123)
#define VALVE_HOGH_ADC_VALUE_MIN  (123/2)//123--->150mA
#define VALVE_HOGH_ADC_VALUE_MAX  (287/2)//287--->350mA

#if (MODULE_ML302_TCP|MODULE_ML307A_TCP)
	#define NEW_STA_PORT			GpioPortA
	#define NEW_STA_PIN				GpioPin4
		
	#define NEW_STA_OP_PORT		    GpioPortF
	#define NEW_STA_OP_PIN			GpioPin1
#else
	#define NEW_STA_PORT	              	GpioPortC	//λ⹩	
	#define NEW_STA_PIN                 	GpioPin1
	
	#define NEW_STA_OP_PORT		        	GpioPortA
	#define NEW_STA_OP_PIN    	        	GpioPin7
#endif
#define NEW_VALVE_NSLEEP_PORT		  	GpioPortB
#define NEW_VALVE_NSLEEP_PIN		  	GpioPin7
	
#define NEW_VALVE_OPEN_PORT			    GpioPortF
#define NEW_VALVE_OPEN_PIN			  	GpioPin5
	
#define NEW_VALVE_CLOSE_PORT		  	GpioPortF
#define NEW_VALVE_CLOSE_PIN	    		GpioPin4  

#define NEW_VALVE_V_CHECK_PORT	    	GpioPortC	
#define NEW_VALVE_V_CHECK_PIN       	GpioPin3

#define NEW_STA_CL_PORT		          	GpioPortA
#define NEW_STA_CL_PIN              	GpioPin6

/*״̬״̬*/
enum{
	VALVE_IDLE = 0,
	VALVE_S1,
	VALVE_S2,
	VALVE_S3,
	VALVE_S4
};


/*/ָ*/
#define VALVE_TO_OPEN       		0x55       /*ָ*/
#define VALVE_TO_CLOSE      		0x99       /*طָ*/
#define VALVE_TO_HALF_OPEN  		0xAA       /*뿪ָ*/
#define VALBE_CLOSE_GENERAL			0xBB		//ͨط
#define VALBE_CLOSE_LOCK			0xCC		//Ȩ޹ط


/*״̬*/
enum{
	VALVE_STATE_OPEN = 1,				//ͨ״̬
	VALVE_STATE_OPEN_EMERGENCY,			//Ӧ״̬
	VALVE_STATE_CLOSE,					//ͨط
	VALVE_STATE_CLOSE_EMERGENCY,		//Ӧط
	VALVE_STATE_CLOSE_LOCK				//Ȩ޹ط	
};


/*λ*/
#define VALVE_IN_PLACE          0       /*ŵλ*/
#define VALVE_NOT_IN_PLACE      1       /*ŵλ*/

/**⵽λ*/
#define VALVE_STA_CL        Gpio_GetInputIO(NEW_STA_CL_PORT, NEW_STA_CL_PIN)
#define VALVE_STA_OP        Gpio_GetInputIO(NEW_STA_OP_PORT, NEW_STA_OP_PIN)


#define OPEN_POWER_ON           0
#define OPEN_POWER_OFF          1    
#define CLOSE_POWER_ON          0
#define CLOSE_POWER_OFF         1 


void ValveStartTask(u8 state);
void ValveInit(void);
void ValveActMachineDriver(void);
void ValveMachineDriver(void);
void ValveAdcMachineDriver(void); 
u8 ValveIfIdle(void);
u8 ValveIfSleep(void);
void ValvePreSleep(void);
void ValveWakeSleep(void);
u8 ValveGetState(void);
u8  ValveGetLineInSpace(void);
void ValveUpdatePara(void);
void ValveStoreRcvState(u8 state);
#ifdef __cplusplus
}
#endif
#endif

