/************************************************************************************
* @Copyright (c)	  :(C)2020, Qindao ieslab Co., Ltd
* @FileName   		  :hc32_clktrim_driver.c
* @Author           :QDIES PLATFORM TEAM
* @Version          :V1.0
* @Date             :2020-07-01
* @Description      :
************************************************************************************/
#include "UWater_clktrim_driver.h"
#include "UWater_rtcc_driver.h"
#include "UWater_frame_app.h"
#include "SOE.h"

volatile uint8_t u8TrimTestFlag = 0;

static u8 clktrim_machine_state = CLKTRIM_MACHINE_S0;
volatile u8 TrimOkFlag = 0;
static u8 trim_cnt = 0;
static CLKTRIM_INFO clktrim_info;
volatile uint32_t u32CalCnt; 

void ClkTrimInit(void)
{
	stc_trim_cfg_t stcCfg;

    //TRIMʱ
    Sysctrl_SetPeripheralGate(SysctrlPeripheralTrim, TRUE);
     
    //TRIMУ׼
    stcCfg.enMON     = TrimMonDisable;
    stcCfg.enREFCLK  = TrimRefMskXTL;               //οʱ:ⲿʱ
    stcCfg.enCALCLK  = TrimCalMskRCH;               //У׼ʱ:ڲʱ
    stcCfg.u32RefCon = REF_CON;                     //100msУ׼ʱ䣨ӸʱTRIMȣ
    stcCfg.u32CalCon = 0xffffffffu;                 //ΪĬֵ
    Trim_Init(&stcCfg);
    
    ///< TRIMжʹ
    Trim_EnableIrq();
    ///< ʹܲTRIM ϵͳж
    EnableNvic(CLKTRIM_IRQn, IrqLevel3, TRUE);
}
/*******************************************************************************
 * TRIM 
 ******************************************************************************/ 
static void clktrim_close(void)
{
	Trim_Stop(); //ֹͣУ׼
	Sysctrl_SetPeripheralGate(SysctrlPeripheralTrim, FALSE); //TRIMʱ
	Trim_DisableIrq(); //TRIMжϽֹ
	NVIC_DisableIRQ(CLKTRIM_IRQn); //TRIMϵͳж
	trim_cnt = 0;
}
///***************************************************************************
//* @fun_name : void StartClkTrim(void)
//* @brief    : ʱУ׼ӿڣⲿ
// ***************************************************************************/
//void StartClkTrim(void)
//{
//    s_clktrim_start_flg = TRUE;
//}
/*******************************************************************************
 * TRIM Ƿ
 ******************************************************************************/ 
u8 ClkTrimIfIdle(void)
{
	if(CLKTRIM_MACHINE_S0 == clktrim_machine_state)
	{
		return TASK_IDLE;
	}
	else
	{
		return TASK_BUSY;
	}
}
/***************************************************************************
* @fun_name : void ClktrimMainMachine(void)
* @brief    : ʱУ׼ģռѭ
 ***************************************************************************/
//u8 check_count=0;
void ClktrimMainMachine(void)
{
	switch(clktrim_machine_state)
	{
		case CLKTRIM_MACHINE_S0:
		{	
			if(FrameCheckMsgApp(MsgBLE_Clktrim))
			{
				FrameClearMsgApp(MsgBLE_Clktrim);
				clktrim_info.adjust_direction_flg = DIRECTIONLESS;       //޷
                TrimOkFlag = 0;
                ClkTrimInit();
                Trim_Run(); //TRIMУ׼
                trim_cnt = 1;
                RtccSetTimer(RTCC_TIMER_CLKTRIM_TOTAL, 20);
                clktrim_machine_state = CLKTRIM_MACHINE_S1;   
			}
		}
		break;		
		case CLKTRIM_MACHINE_S1:
		{
			if((TRIM_DONE == TrimOkFlag)                              //У׼
				|| (TRIM_OVERFLOW == TrimOkFlag)                      //ӼУ׼ʱӣXTL쳣
				|| (trim_cnt >= TRIM_MAX_NUM)                         //У׼
				|| (0 == RtccCheckTimer(RTCC_TIMER_CLKTRIM_TOTAL))) //ʱʱ䵽
			{
				FrameSetMsgApp(MsgAddr_Change);//Ϣ
				SaveNewSoe(clktrim_info.diff_value&0xFFFF, (clktrim_info.diff_value>>16)&0xFF);//ʱУ׼
				SaveNewSoe(M0P_SYSCTRL->RCH_CR_f.TRIM, 0x99);//ʱУ׼
				
				trim_cnt = 0;
				clktrim_close();
				clktrim_machine_state = CLKTRIM_MACHINE_S0;
			}
		}
		break;
		
		default:
		{
			clktrim_close();
			clktrim_machine_state = CLKTRIM_MACHINE_S0;
		}
		break;
	}
}
/*******************************************************************************
 * TRIM жϷ
 ******************************************************************************/  
void ClkTrim_IRQHandler(void)
{
	if(TRUE == Trim_GetIntFlag(TrimStop))
	{
		u32CalCnt = Trim_CalCntGet();  //ȡУ׼ʱӵļֵ

		if(u32CalCnt == CAL_CON_TARGET)  //ֵڱ׼ֵ
		{
			Trim_Stop();
			///< У׼,ʱTRIMֵΪƵֵ
			TrimOkFlag = TRIM_DONE;
		}
		else if(u32CalCnt < CAL_CON_TARGET) //ֵСڱ׼ֵ  Ҫtrimֵ
		{
			Trim_Stop();
			if(clktrim_info.adjust_direction_flg == DIRECTIONLESS || clktrim_info.adjust_direction_flg == UPWARD)  
			{
				clktrim_info.adjust_direction_flg = UPWARD;	
				clktrim_info.diff_value = CAL_CON_TARGET - u32CalCnt;    //õֵ	
				///< ΪﵽĿ꾫ȣTRIMֵ1У׼	
				M0P_SYSCTRL->RCH_CR_f.TRIM += 1;
				Trim_Run();
				trim_cnt++;
			}
			else //ı
			{
				if((CAL_CON_TARGET - u32CalCnt) > clktrim_info.diff_value)  //ǰĲֵһֵ һtrimֵ
				{
					 M0P_SYSCTRL->RCH_CR_f.TRIM +=1;
					 TrimOkFlag = TRIM_DONE;
				}
				else
				{
					 TrimOkFlag = TRIM_DONE;
				}
			}
		}
		else if(u32CalCnt > CAL_CON_TARGET) //ֵڱ׼ֵ  ҪСtrimֵ
		{
			Trim_Stop();
			if(clktrim_info.adjust_direction_flg == DIRECTIONLESS || clktrim_info.adjust_direction_flg == DOWNWARD)  
			{
				clktrim_info.adjust_direction_flg = DOWNWARD;	
				clktrim_info.diff_value =  u32CalCnt - CAL_CON_TARGET; //õֵ
				///< ΪﵽĿ꾫ȣTRIMֵ1У׼	
				M0P_SYSCTRL->RCH_CR_f.TRIM -= 1;
				Trim_Run();
				trim_cnt++;
			}
			else //ı
			{
				if((u32CalCnt - CAL_CON_TARGET) > clktrim_info.diff_value)  //ǰĲֵһֵ һtrimֵ
				{
					 M0P_SYSCTRL->RCH_CR_f.TRIM -= 1;
					 TrimOkFlag = TRIM_DONE;
				}
				else
				{
					 TrimOkFlag = TRIM_DONE;
				}
			}			
		}
	}
	if(TRUE == Trim_GetIntFlag(TrimCalCntOf))
	{
		Trim_Stop();
		///< У׼ʱӼXTL쳣
		TrimOkFlag = TRIM_OVERFLOW;
	}
}
